image: node:14.15-alpine

variables:
  DOCKER_DRIVER: overlay
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"
  GIT_DEPTH: "0"

stages:
  - build
  - test
  - visualize

cache:
  paths:
    - node_modules/

node-build:
  stage: build
  script:
    - npm install
    - npm run build
  artifacts:
    expire_in: 1h
    paths:
      - node_modules/

unit-integration-test:
  stage: test
  script:
    - npm run test:junit
  coverage: /All\sfiles.*?\s+(\d+.\d+)/
  artifacts:
    when: always
    paths:
      - coverage
    reports:
      junit:
        - junit.xml
  dependencies:
    - node-build


e2e-test:
  stage: test
  script:
    - npm run test
  dependencies:
    - node-build

sonarcloud-check:
  stage: visualize
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
  only:
    - merge_requests
    - master
